

mergeusimclls = function(usim,inter,lemmas,round) {
     usimwinter = usim[usim$lemma %in% lemmas,]
     usimwinter$clinter = "NIL"
     usimwinter$inter = "NIL" # 
     for (i in 1:nrow(usimwinter)) {
       ls1 = as.character(usimwinter[i,]$lexsub_id1)
       ls2 = as.character(usimwinter[i,]$lexsub_id2)    
       interinter = as.character(inter[(inter$lexsub_id1 ==ls1) & (inter$lexsub_id2 ==ls2),]$lexsubinter)
       if (length(interinter) > 1) { # sanity check
	       print(paste("interinter more than one",interinter))
       }
	usimwinter[i,]$inter = interinter
        usimwinter[i,]$clinter =  inter[inter$lexsub_id1 ==ls1 &inter$lexsub_id2 ==ls2,]$cllsinter
     }    
   usimwinter
}

# lemmas all clls lemmas
# lemmas1 all clls but in usim1
# lemmas2 all clls but in usim2
# score "z" if you want to use zscores (usimmeanz)
corrall = function(usim1,usim2,inter,lemmas1,lemmas2,lemmas,score) {

	table = corrinter(inter,lemmas)	# order by this	
	table = corrusiminterrnd(usim2,inter,lemmas2,2,table,score) 
	# do r2 first and take that value, more annotators for usim
	table = corrusiminterrnd(usim1,inter,lemmas1,1,table,score)		
	table
}

# lemmasr1 should have lemmas from r2 removed
collateresults = function(results,midr1,midr2,iaar1,iaar2,lemmasr1,lemmasr2) {
	  results$mid = 0
	  results$iaa = 0
	  results = joinres(results,midr1,iaar1,lemmasr1)
	  results = joinres(results,midr2,iaar2,lemmasr2)

results
}

orderresbylemma = function(table,lemmas) {
	lemma.table = data.frame(lemma = lemmas)
	lemma.table$inclin = table[order(table$inclin),]$lemma # do for each column
	lemma.table$inmj = table[order(table$inmj),]$lemma # do for each column
	lemma.table$clinmj = table[order(table$clinmj),]$lemma # do for each column
	lemma.table$mid = table[order(table$mid, decreasing=TRUE),]$lemma # do for each column
	lemma.table$iaa = table[order(table$iaa),]$lemma # do for each column
	lemma.table
}

joinres = function(results,mid,iaa,lemmas) {
	iaa = iaa[iaa$lemma != "all",]
	for (lemma in lemmas) {
           results[results$lemma == lemma,]$mid = mid[mid$lemma == lemma,]$mid
           results[results$lemma == lemma,]$iaa = iaa[iaa$lemma == lemma,]$rho
	 }
	 results
}



corrusiminterrnd = function(usim,inter,lemmas,round,result,score) {		
	retv = corrusiminter(usim,inter,lemmas,round,"all",result,score) 
	for (lemma in lemmas) {
		usim.l = usim[usim$lemma == lemma,]
		retv = corrusiminter(usim.l,inter,c(lemma),round,lemma,retv,score)
	}
	retv
}

corrusiminter = function(usim,inter,lemmas,round,lemma,retv,score) {	     
	     usiminter = mergeusimclls(usim,inter,lemmas,round) # 
	     usiminter.ne = usiminter
	     # needed because there are round 1 lemmas without subs for overlap
	     if (round == 1) {
	       usiminter.ne = usiminter.ne[usiminter.ne$inter!= "EXCEPT",]
	     }
	     if (score == "z") {
	     	cor= cor.test(usiminter.ne$inter,usiminter.ne$usimmeanz, method="spearman", exact=FALSE) # zscores
	      }
	     else {
		cor= cor.test(usiminter.ne$inter,usiminter.ne$meanj, method="spearman", exact=FALSE)
	     }
	 rho = round(cor$estimate,3)
	 if (lemma == "all") {
	             print(paste("Correlation inter token and usim mean ","Usim round",round,"lemma:","all",cor$estimate,cor$p.value))
	         }
	 if (retv[retv$lemma == lemma,]$inmj == 0) { # otherwise use previous val
	 	 retv[retv$lemma == lemma,]$inmj = rho
	}	
	if (score == "z") { 
	         cor= cor.test(usiminter$clinter,usiminter$usimmeanz , method="spearman", exact=FALSE) #zscores
	}
	else {
		 cor= cor.test(usiminter$clinter,usiminter$meanj , method="spearman", exact=FALSE)
         }
	 rho = round(cor$estimate,3)
	 if (retv[retv$lemma == lemma,]$clinmj == 0) { 
	    retv[retv$lemma == lemma,]$clinmj = rho	 	 
  	  }
	  if (lemma == "all") {
            print(paste("Correlation CL inter and usim mean ","Usim round",round,cor$estimate,cor$p.value))
	 }
	 retv
}

printsentnumb = function(inter,lemmas) {
	      retv = data.frame(lemma = lemmas)
	      retv$sents = 0
	      for (lemma in lemmas) {
	      	  inter.l = inter[inter$wordpos == lemma,]
		  sent = levels(as.factor(c(inter.l$LS_id1,inter.l$LS_id2)))
		  retv[retv$lemma == lemma,]$sents = length(sent)
	      }
	      retv

}

corrinter = function(inter,lemmas) {
	 retv = data.frame(lemma = c("all", lemmas))
	 retv$inclin = 0 
	 retv$inmj = 0
	 retv$clinmj = 0
	 inter.l = inter[inter$lemma %in% lemmas,]
	 inter.l.noexcept  =  inter.l[inter.l$lexsubinter != "EXCEPT",] 
	 cor= cor.test(inter.l.noexcept$lexsubinter,inter.l.noexcept$cllsinter , method="spearman", exact=FALSE) 
	 rho = round(cor$estimate,3)	 
	 retv[retv$lemma == "all",]$inclin = rho
	 rho = round(cor$estimate,3)
	 for (lemma in lemmas) {
	     inter.l.noexcept.l = inter.l.noexcept[inter.l.noexcept$lemma ==lemma,]
	     cor= cor.test(inter.l.noexcept.l$lexsubinter,inter.l.noexcept.l$cllsinter, method="spearman", exact=FALSE)
	     rho = round(cor$estimate,3)	 
	     retv[retv$lemma == lemma,]$inclin = rho
	 }
	 retv.sort = retv[(order(retv$lemma)),] # view in debugger
	 retv.sort = retv[(order(retv$inclin)),]
	 retv
}


myprintlatextab = function(table) {
	ntable = data.frame()
	for (i in 1:nrow(table)) {
	    for (c in 1:ncol(table)) {
	    	ntable[i,c] = paste(as.character(table[i,c])," & ")
	     }
	     ntable[i,c] = paste(as.character(table[i,c]),(" \\ "))
	}
	ntable	
}


# usimr2ind.cllslemma$response
# usimr1ind.cllslemma$lemmap =usimr1ind.cllslemma$lemma 
# usimr1ind.cllslemma$response = usimr1ind.cllslemma$judgment
avgmid = function(usim,lemmas) {
       retv = data.frame(lemma = lemmas)
       retv$mid = 0
       for (lemma in lemmas) {
           tot = nrow(usim[(usim$lemmap == lemma),])
       	   usim.l = usim[(usim$lemmap == lemma) & (usim$response %in% c(2,3,4)),]
	   mid =  length(usim.l$response) /tot
	   retv[retv$lemma == lemma,]$mid = round(mid,3)
	   #sum(usim.l$response)			  	
       }
       retv.sort = retv[(order(retv$mid)),]
       print(retv.sort)
       print(paste("mean",mean(retv$mid)))
    retv   
}

# usimr2ind.cllslemma$response
# usimr1ind.cllslemma$lemmap =usimr1ind.cllslemma$lemma 
# usimr1ind.cllslemma$response = usimr1ind.cllslemma$judgment
summid = function(usim,lemmas) {
       retv = data.frame(lemma = lemmas)
       retv$mid = 0
       for (lemma in lemmas) {
       	   usim.l = usim[(usim$lemmap == lemma) & (usim$response %in% c(2,3,4)),]
	   retv[retv$lemma == lemma,]$mid = sum(usim.l$response)	   	   
       }
       retv.sort = retv[(order(retv$mid)),]
       print(retv.sort)
       print(paste("mean",mean(retv$mid)))
      retv   
}

zscore = function(df) {
    df$z = "NIL"
    sdev = sd(df$mid)
    mean = mean(df$mid)
    for (i in 1:nrow(df)) {
	zs = (df[i,]$mid - mean) / sdev
	zs = round(zs,3)
	df[i,]$z = zs	
     }
     df
}
